
set ::multimode::db "/var/lib/humaxtv/mm.db"

proc ::multimode::query {mmdb type} {
	set ll {}
	foreach ret [$mmdb query \
	    {select lcn from channel where type = "%s"} $type] {
		lassign $ret x lcn
		lappend ll $lcn
	}
	return $ll
}

proc ::multimode::run {args} {
	if {![file exists $::multimode::db]} return
	if {[catch {set mmdb [sqlite3.open $::multimode::db]}]} return

	lassign [system padding] ::multimode::pre ::multimode::post
	foreach rec [$mmdb query {select var, nval from settings}] {
		lassign $rec x var x val
		set ::multimode::$var $val
	}

	# Build LCN lists
	set pad [query $mmdb "pad"]
	set ar [query $mmdb "ar"]

	multimodelog "PRE:  $::multimode::pre" 2
	multimodelog "POST: $::multimode::post" 2
	multimodelog "PAD LIST: $pad" 2
	multimodelog "AR LIST:  $ar" 2

	set commit 0
	foreach r [rsv list] {
		set lcn [$r get usLcn]
		multimodelog "multimode: checking [$r name] - $lcn" 2

		if {$lcn in $pad} {
			multimodelog "    in pad list" 2
			set epre $::multimode::pre
			set epost $::multimode::post
		} elseif {$lcn in $ar} {
			multimodelog "    in ar list" 2
			set epre 0
			set epost 0
		} else {
			continue
		}

		if {[$r get ulPreOffset] == $epre &&
		    [$r get ulPostOffset] == $epost} {
			multimodelog "    already correct" 2
			continue
		}

		$r clear_ulslot
		if {$epre == 0 && $epost == 0} {
			$r set_unpad
			multimodelog "multimode: converting [$r name] to AR"
		} else {
			multimodelog "multimode: converting [$r name] to pad <$epre,$epost>"
			$r set_pad $epre $epost
		}
		$r insert pending 0 1
		incr commit
	}
	if {$commit} { rsv commit 0 }
}


